<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfVehicleGroupIdentifier ArrayType
 * @subpackage Arrays
 */
class ArrayOfVehicleGroupIdentifier extends AbstractStructArrayBase
{
    /**
     * The VehicleGroupIdentifier
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\VehicleGroupIdentifier[]
     */
    public $VehicleGroupIdentifier;
    /**
     * Constructor method for ArrayOfVehicleGroupIdentifier
     * @uses ArrayOfVehicleGroupIdentifier::setVehicleGroupIdentifier()
     * @param \StructType\VehicleGroupIdentifier[] $vehicleGroupIdentifier
     */
    public function __construct(array $vehicleGroupIdentifier = array())
    {
        $this
            ->setVehicleGroupIdentifier($vehicleGroupIdentifier);
    }
    /**
     * Get VehicleGroupIdentifier value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\VehicleGroupIdentifier[]|null
     */
    public function getVehicleGroupIdentifier()
    {
        return isset($this->VehicleGroupIdentifier) ? $this->VehicleGroupIdentifier : null;
    }
    /**
     * This method is responsible for validating the values passed to the setVehicleGroupIdentifier method
     * This method is willingly generated in order to preserve the one-line inline validation within the setVehicleGroupIdentifier method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateVehicleGroupIdentifierForArrayConstraintsFromSetVehicleGroupIdentifier(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfVehicleGroupIdentifierVehicleGroupIdentifierItem) {
            // validation for constraint: itemType
            if (!$arrayOfVehicleGroupIdentifierVehicleGroupIdentifierItem instanceof \StructType\VehicleGroupIdentifier) {
                $invalidValues[] = is_object($arrayOfVehicleGroupIdentifierVehicleGroupIdentifierItem) ? get_class($arrayOfVehicleGroupIdentifierVehicleGroupIdentifierItem) : sprintf('%s(%s)', gettype($arrayOfVehicleGroupIdentifierVehicleGroupIdentifierItem), var_export($arrayOfVehicleGroupIdentifierVehicleGroupIdentifierItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The VehicleGroupIdentifier property can only contain items of type \StructType\VehicleGroupIdentifier, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set VehicleGroupIdentifier value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\VehicleGroupIdentifier[] $vehicleGroupIdentifier
     * @return \ArrayType\ArrayOfVehicleGroupIdentifier
     */
    public function setVehicleGroupIdentifier(array $vehicleGroupIdentifier = array())
    {
        // validation for constraint: array
        if ('' !== ($vehicleGroupIdentifierArrayErrorMessage = self::validateVehicleGroupIdentifierForArrayConstraintsFromSetVehicleGroupIdentifier($vehicleGroupIdentifier))) {
            throw new \InvalidArgumentException($vehicleGroupIdentifierArrayErrorMessage, __LINE__);
        }
        if (is_null($vehicleGroupIdentifier) || (is_array($vehicleGroupIdentifier) && empty($vehicleGroupIdentifier))) {
            unset($this->VehicleGroupIdentifier);
        } else {
            $this->VehicleGroupIdentifier = $vehicleGroupIdentifier;
        }
        return $this;
    }
    /**
     * Add item to VehicleGroupIdentifier value
     * @throws \InvalidArgumentException
     * @param \StructType\VehicleGroupIdentifier $item
     * @return \ArrayType\ArrayOfVehicleGroupIdentifier
     */
    public function addToVehicleGroupIdentifier(\StructType\VehicleGroupIdentifier $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\VehicleGroupIdentifier) {
            throw new \InvalidArgumentException(sprintf('The VehicleGroupIdentifier property can only contain items of type \StructType\VehicleGroupIdentifier, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->VehicleGroupIdentifier[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\VehicleGroupIdentifier|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\VehicleGroupIdentifier|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\VehicleGroupIdentifier|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\VehicleGroupIdentifier|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\VehicleGroupIdentifier|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string VehicleGroupIdentifier
     */
    public function getAttributeName()
    {
        return 'VehicleGroupIdentifier';
    }
}
